Attribute VB_Name = "cal"
Public nbjours(1 To 12) As Integer
Public lesmois(1 To 12) As String
Public lesjours(0 To 6) As String

Public Type MaDate
    jour As Integer
    mois As Integer
    annee As Integer
End Type

Public Type Heur
    heure As Integer
    minut As Integer
End Type

Public Type donnees
    mode As Integer
    date_deb As MaDate
    date_fin As MaDate
    heur_deb As Heur
    heur_fin As Heur
    titre As String
    texte As String
End Type

'renvoie pour un jour donne si c'est un lundi,...
Public Function keljour(a As MaDate) As Integer
Dim b As Integer, k As Integer

'base : 1 janvier 2006 = dimanche
'1 an = 365 jours => +1  chaque fois sauf si bissextile

b = 0

If a.annee >= 2006 Then
b = (a.annee - 2006) Mod 7
b = (b + ((a.annee - 2005) \ 4)) Mod 7 'on ajoute les annes bisextiles strictement entre 2006 et l'anne

For k = 1 To (a.mois - 1)
b = b + nbjours(k)
Next k

'si anne bisextile
If ((a.annee Mod 4) = 0) And a.mois >= 3 Then
b = b + 1
End If

b = (b + a.jour - 1) Mod 7
b = (6 + b) Mod 7 ' car dimanche 1er janvier 2006

Else

'technique : on cherche le jour du 1er janvier puis on ajoute
b = (a.annee - 2006) Mod 7
b = (b - ((2008 - a.annee) \ 4)) Mod 7 'on ajoute les annes bisextiles entre 2006 et l'anne de telle sorte que 2004 soit compte

For k = 1 To (a.mois - 1)
b = (b + nbjours(k)) Mod 7
Next k

'si anne bisextile
If ((a.annee Mod 4) = 0) And a.mois >= 3 Then
b = b + 1
End If

b = (b + a.jour - 1) Mod 7
b = (6 + b) Mod 7 ' car dimanche 1er janvier 2006

End If


keljour = b

End Function

Public Sub Initialise()

nbjours(1) = 31
nbjours(2) = 28
nbjours(3) = 31
nbjours(4) = 30
nbjours(5) = 31
nbjours(6) = 30
nbjours(7) = 31
nbjours(8) = 31
nbjours(9) = 30
nbjours(10) = 31
nbjours(11) = 30
nbjours(12) = 31

lesmois(1) = "janvier"
lesmois(2) = "fvrier"
lesmois(3) = "mars"
lesmois(4) = "avril"
lesmois(5) = "mai"
lesmois(6) = "juin"
lesmois(7) = "juillet"
lesmois(8) = "aot"
lesmois(9) = "septembre"
lesmois(10) = "octobre"
lesmois(11) = "novembre"
lesmois(12) = "dcembre"

lesjours(0) = "lundi"
lesjours(1) = "mardi"
lesjours(2) = "mercredi"
lesjours(3) = "jeudi"
lesjours(4) = "vendredi"
lesjours(5) = "samedi"
lesjours(6) = "dimanche"

End Sub

Public Function is_after_day(a As MaDate, b As MaDate) As Boolean 'true si a >= b

is_after_day = False

If a.annee > b.annee Then
is_after_day = True
Exit Function
End If

If a.annee < b.annee Then
is_after_day = False
Exit Function
End If

If a.mois > b.mois Then
is_after_day = True
Exit Function
End If

If a.mois < b.mois Then
is_after_day = False
Exit Function
End If

If a.jour >= b.jour Then
is_after_day = True
Exit Function
End If

If a.jour < b.jour Then
is_after_day = False
Exit Function
End If

End Function

Public Function is_after_hour(a As Heur, b As Heur) As Boolean  'true si a >=b

is_after_hour = False

If a.heure > b.heure Then
is_after_hour = True
Exit Function
End If

If a.heure < b.heure Then
is_after_hour = False
Exit Function
End If

If a.minut >= b.minut Then
is_after_hour = True
Exit Function
End If

If a.minut < b.minut Then
is_after_hour = False
Exit Function
End If

End Function

Public Function egal(a As MaDate, b As MaDate) As Boolean
egal = True
If a.annee <> b.annee Then egal = False
If a.jour <> b.jour Then egal = False
If a.mois <> b.mois Then egal = False

End Function

'diffrence de 2 heures
Public Function diff(a As Heur, b As Heur) As Heur

If a.heure = b.heure Then
diff.heure = 0
diff.minut = a.minut - b.minut
Else
diff.minut = a.minut + 60 - b.minut
diff.heure = a.heure - b.heure - 1
    If diff.minut >= 60 Then
    diff.minut = diff.minut - 60
    diff.heure = diff.heure + 1
    End If
End If

End Function
